/***
 * State of the partition as defined by Alarm.com
 * @readonly
 * @enum {number}
 */
export declare enum SYSTEM_STATES {
    UNKNOWN = 0,
    DISARMED = 1,
    ARMED_STAY = 2,
    ARMED_AWAY = 3,
    ARMED_NIGHT = 4
}
/***
 * State of the sensor as defined by Alarm.com
 * @readonly
 * @enum {number}
 */
export declare enum SENSOR_STATES {
    UNKNOWN = 0,
    CLOSED = 1,
    OPEN = 2,
    IDLE = 3,
    ACTIVE = 4,
    DRY = 5,
    WET = 6
}
/***
 * State of the light as defined by Alarm.com
 * @readonly
 * @enum {number}
 */
export declare enum LIGHT_STATES {
    ON = 2,
    OFF = 3
}
/***
 * State of the lock as defined by Alarm.com
 * @readonly
 * @enum {number}
 */
export declare enum LOCK_STATES {
    SECURED = 1,
    UNSECURED = 2
}
/***
 * State of the garage as defined by Alarm.com
 * @readonly
 * @enum {number}
 */
export declare enum GARAGE_STATES {
    OPEN = 1,//double check
    CLOSED = 2
}
/***
 * State of the thermostat as defined by Alarm.com
 * @readonly
 * @enum {number}
 */
export declare enum THERMOSTAT_STATES {
    OFF = 1,
    HEATING = 2,
    COOLING = 3,
    AUTO = 4
}
/***
 * Relation types as defined by Alarm.com.
 * Relationship types tell you what object is being sent from the API.
 * @readonly
 */
export declare enum REL_TYPES {
    CONFIGURATION = "systems/configuration",
    PARTITION = "devices/partition",
    SENSOR = "devices/sensor",
    LIGHT = "devices/light",
    LOCK = "devices/lock",
    GARAGE_DOOR = "devices/garage-door",
    CAMERA = "video/camera",
    THERMOSTAT = "devices/thermostat",
    GEO_DEVICE = "geolocation/geo-device",
    GEO_FENCE = "geolocation/fence",
    SCENE = "automation/scene",
    ACCESS_CONTROL = "devices/access-control-access-point-device"
}
